﻿Imports System.Net
Imports RecipeEditorViaMC3eJet.MelsecCommunication

Public Class frmConnect
	Public Sub New()
		InitializeComponent()
	End Sub


	Public Property Address As String
	Public Property Port As Integer
	Public Property Encoding As TextEncodeFlags
	Public Property ConnectAsync As Boolean


	Private Sub frmConnect_Shown(sender As Object, e As EventArgs) Handles Me.Shown
		TopMost = DirectCast(Owner, frmMain).TopMost

		txtIPAddress.Text = Address
		txtPort.Text = Port.ToString

		For Each Encoding As TextEncodeFlags In [Enum].GetValues(GetType(TextEncodeFlags))
			cmbEncoding.Items.Add(New KeyValuePair(Of TextEncodeFlags, String)(Encoding, [Enum].GetName(GetType(TextEncodeFlags), Encoding)))
		Next
		cmbEncoding.ValueMember = "Key"
		cmbEncoding.DisplayMember = "Value"
		cmbEncoding.SelectedIndex = Array.IndexOf([Enum].GetValues(GetType(TextEncodeFlags)), Encoding)

		chkConnectAsync.Checked = ConnectAsync
	End Sub


	Private Sub cmdOK_Click(sender As Object, e As EventArgs) Handles cmdOK.Click
		Dim EndPointTest As IPEndPoint

		Try
			EndPointTest = New IPEndPoint(IPAddress.Parse(txtIPAddress.Text), CInt(txtPort.Text))
			Address = txtIPAddress.Text
			Port = CInt(txtPort.Text)
			Encoding = DirectCast(cmbEncoding.SelectedItem, KeyValuePair(Of TextEncodeFlags, String)).Key
			ConnectAsync = chkConnectAsync.Checked

			DialogResult = DialogResult.OK
		Catch ex As Exception
			MessageBox.Show("Not good.")
		End Try
	End Sub

	Private Sub cmdCancel_Click(sender As Object, e As EventArgs) Handles cmdCancel.Click
		DialogResult = DialogResult.Cancel
	End Sub
End Class